store = require 'store'
monitor = require 'centralmonitor'

local params = {smtp={}, header={}}

-- URL of monitor web Service (format - http://host:port/weburl/)
params.url =                   'http://localhost:6544/monitor/'

-- Emails will only be sent this frequently (in minutes)
params.threshold =             30

-- Mail Server settings
params.smtp.server=            'smtp://mail.example.com:25' -- 'smtp://server:port'
params.smtp.username=          'user'                       -- username 
params.smtp.password=          'pass'                       -- password

-- Email settings
params.header.senderName =     'Your Name'
params.smtp.from =             'first.last@example.com'
params.smtp.to =               {'first.last@example.com','it-dept@example.com'}
params.header.subject =        'Iguana Server(s) may be down'
params.smtp.use_ssl =          'try'


function main()
   
   iguana.stopOnError(false)
   -- Setup local variables
   local E =                ''
   local time =             os.ts.time()
   local thresholdMinutes = params.threshold * 60
   local problems =         store.get('Status-Problems')
   local lastEmail =        store.get('Status-Email')
  
   -- Check to see if any servers haven't called home
   local issues = monitor.checkForIssues(params)
   
   if #issues.server > 0 then
      
      -- Only send an email if the threshold is exceeded 
      if os.ts.difftime(time, lastEmail) > thresholdMinutes then
         
         -- Build the email to be sent
         E = monitor.buildEmail(issues, params)         
     
         -- Send email and set flags
         store.put('Status-Email', os.ts.time())
         monitor.sendEmail(E, '1', params) 
         
      end
   else
      
      
      -- Check if problems have been resolved, send email
      if problems == '1' then         
         E = 'Great, it looks like all your servers are up and running!'            
         
         -- Send Email         
         monitor.sendEmail(E, '0', params)
         
      end
   end

end